
      SUBROUTINE SYMFAK(IA,JA,IU,JU,IP,N,MEDU)
C  FACTORIZACION TRIANGULAR SIMBOLICA UT*D*U DE GAUSS PARA UNA MATRIZ
C  SIMETRICA IA,JA DE N*N EN R(S)FD. METODO SHERMAN.
C
C  DATOS.
C  IA,JA  ESTRUCTURA DE LA MATRIZ A DADA EN R(S)FD.
C  N  ORDEN DE A.
C  MEDU  MEMORIA RESERVADA PARA JU.
C
C  RESULTADOS.
C  IU,JU  ESTRUCTURA DEL FACTOR TRIANGULAR SUPERIOR EN R(S)FD.
C
C  VECTOR AUXILIAR.
C  IP(N)  LISTAS DE NO-CEROS PRIMEROS DE FILA DE CADA COLUMNA.
C
C  SUBPROGRAMAS=NINGUNO.
C  STOP=0
C
      DIMENSION IA(1),JA(1),IU(1),JU(1),IP(1)
      NM=N-1
      NH=N+1
      DO 10 I=1,N
      IU(I)=0
10    IP(I)=0
      JP=1
      DO 20 I=1,NM
      JPI=JP
      JPP=N+JP-I
      MIN=NH
      IAA=IA(I)
      IAB=IA(I+1)-1
      IF(IAB.GE.IAA) GO TO 80
      IF(IAB.EQ.IAA-1) GO TO 30
      GOTO 360
80    JJ=JP+IAB-IAA-1
      IF(JJ.GT.MEDU)GOTO 160
      DO 40 J=IAA,IAB
      JJ=JA(J)
      JU(JP)=JJ
      JP=JP+1
      IF(JJ.LT.MIN)MIN=JJ
40    IU(JJ)=I
30    LAST=IP(I)
      IF(LAST.EQ.0)GOTO 100
      L=LAST
50    L=IP(L)
      LH=L+1
      IUA=IU(L)
      IUB=IU(LH)-1
      IF(LH.EQ.I)IUB=JPI-1
      JJ=JP+IUB-IUA-1
      IF(JJ.GT.MEDU)GOTO 160
      IU(I)=I
      DO 60 J=IUA,IUB
      JJ=JU(J)
      IF(IU(JJ).EQ.I)GOTO 60
      JU(JP)=JJ
      JP=JP+1
      IU(JJ)=I
      IF(JJ.LT.MIN)MIN=JJ
60    CONTINUE
      IF(JP.EQ.JPP)GOTO 170
      IF(L.NE.LAST)GOTO 50
100   IF(MIN.EQ.NH)GOTO 20
170   LAST=IP(MIN)
      IF(LAST.EQ.0)GOTO 70
      IP(I)=IP(LAST)
      IP(LAST)=I
      GOTO 20
70    IP(MIN)=I
      IP(I)=I
20    IU(I)=JPI
      IU(N)=JP
      IU(NH)=JP
      JP=JP-1
C      WRITE(6,15)N,N,JP
      RETURN
160   WRITE(6,165)I,JJ,IAA,IAB
      STOP
360   WRITE(6,365)N,MEDU,JP,I,IAA,IAB
      STOP
C15    FORMAT(1X,'SYMFAK.SE HA GENERADO LA ESTRUCTURA DEL FACTOR U DE UNA MA
C     *TRIZ DE',I5,'*',I5,'.HAY',I6,' NO-CEROS.')
165   FORMAT(1X,' SYMFAK.AL PROCESAR LA FILA',I5,' YA SE REQUIEREN',I6,
     1' LUGARES PARA JU.',2X,'IAA=',I5,2X,'IAB=',I5)
365   FORMAT(1X,'SYMFAK.ERROR',20I5)
      END
